#define		STRICT
#include	<windows.h>
#include	<tchar.h>
#include	<winsock.h>
#ifndef	UNICODE
#include	<stdio.h>
#endif	/* UNICODE */

#define		MAXBUFLEN		256

DWORD		g_dwAppVersion = 2 ;
LPTSTR		g_szProgName = TEXT("") ;
WSADATA		WsaData ;
SOCKADDR_IN	destSockAddr ;
SOCKET		destSocket ;
TCHAR		szDstIpAddr[ MAXBUFLEN ] = TEXT("") ;
TCHAR		szDstPortAddr[ MAXBUFLEN ] = TEXT("") ;
CHAR		sendBuf[ MAXBUFLEN ] ;
BYTE		recvText[ MAXBUFLEN ] ;
TCHAR		sendText[ MAXBUFLEN ] ;

void
help()
{
	_tprintf( TEXT("Usage:\n\t") ) ;
	_tprintf( TEXT("%s HostName[:PortNo] Request-URI Save-File\n"), g_szProgName ) ;
}

void
close_sock()
{
	int		status ;

	status = closesocket( destSocket ) ;
	if ( status == SOCKET_ERROR ) {
		_tprintf( TEXT("%s: closesocket: %d\n"), g_szProgName, WSAGetLastError() ) ;
	}
	if ( WSACleanup() == SOCKET_ERROR ) {
		_tprintf( TEXT("%s: WSACleanup: %d\n"), g_szProgName, WSAGetLastError() ) ;
	}
}

int
_tmain( int argc, LPTSTR argv[] )
{
	HOSTENT		*he ;
	HANDLE		hFile ;
	DWORD		nWrote ;
	ULONG		ulDestAddr ;
	int			status, numSent, numReceived, total, len ;

	g_szProgName = argv[0] ;
	_tprintf( TEXT("GetWeb Ver%d.%02d Copyright(C) 1998 by E.Ito\n"),
			  g_dwAppVersion / 100, g_dwAppVersion % 100 ) ;
	_tprintf( TEXT("             mailto:GHC02331@nifty.ne.jp\n\n") ) ;

	if ( argc <= 3 ) {
		help() ;
		return 99 ;
	}
	_stscanf( argv[1], TEXT("%[^:]"), szDstIpAddr ) ;
	_stscanf( argv[1], TEXT("%*[^:]:%s"), szDstPortAddr ) ;
	if ( !*szDstIpAddr ) {
		_tcscpy( szDstIpAddr, argv[1] ) ;
		*szDstPortAddr = 0 ;
	}
	if ( !*szDstIpAddr ) {
		help() ;
		return 99 ;
	} else if ( !*szDstPortAddr ) {
		_tcscpy( szDstPortAddr, TEXT("80") ) ;
	}

	status = WSAStartup( MAKEWORD(1, 1), &WsaData ) ;
	if ( status != 0 ) {
		_tprintf( TEXT("%s: WSAStartup: %d\n"), g_szProgName, WSAGetLastError() ) ;
		return 99 ;
	}

#ifdef	UNICODE
	wcstombs( sendBuf, szDstIpAddr, sizeof sendBuf ) ;
#else	/* UNICODE */
	strcpy( sendBuf, szDstIpAddr ) ;
#endif	/* UNICODE */
	ulDestAddr = inet_addr( sendBuf ) ;
	if ( ulDestAddr != INADDR_NONE ) {
		memcpy( &destSockAddr.sin_addr, &ulDestAddr, sizeof ulDestAddr ) ;
	} else {
		he = gethostbyname( sendBuf ) ;
		if ( he == NULL ) {
			_tprintf( TEXT("%s: gethostbyname: %d\n"), g_szProgName, WSAGetLastError() ) ;
			if ( WSACleanup() == SOCKET_ERROR ) {
				_tprintf( TEXT("%s: WSACleanup: %d\n"), g_szProgName, WSAGetLastError() ) ;
			}
			return 99 ;
		}
		memcpy( &destSockAddr.sin_addr, he->h_addr, sizeof ulDestAddr ) ;
	}
	destSockAddr.sin_port = htons( (u_short) _ttol( szDstPortAddr ) ) ;
	destSockAddr.sin_family = AF_INET ;

	destSocket = socket( AF_INET, SOCK_STREAM, 0 ) ;
	if ( destSocket == INVALID_SOCKET ) {
		_tprintf( TEXT("%s: socket: %d\n"), g_szProgName, WSAGetLastError() ) ;
		if ( WSACleanup() == SOCKET_ERROR ) {
			_tprintf( TEXT("%s: WSACleanup: %d\n"), g_szProgName, WSAGetLastError() ) ;
		}
		return 98 ;
	}

	_tprintf( TEXT("Connecting to %s:%s..."), szDstIpAddr, szDstPortAddr ) ;
	status = connect( destSocket, (LPSOCKADDR) &destSockAddr, sizeof destSockAddr ) ;
	if ( status == SOCKET_ERROR ) {
		_tprintf( TEXT("\n") ) ;
		_tprintf( TEXT("%s: connect: %d\n"), g_szProgName, WSAGetLastError() ) ;
		close_sock() ;
		return 97 ;
	}
	_tprintf( TEXT("Connected\n") ) ;
	_tprintf( TEXT("Accessing page from %s\n"), argv[2] ) ;

	_tcscpy( sendText, TEXT("GET ") ) ;
	_tcscat( sendText, argv[2] ) ;
	_tcscat( sendText, TEXT("\n") ) ;
//	_tcscat( sendText, TEXT(" HTTP/0.9\n") ) ;
//	_tcscat( sendText, TEXT("Cache-Control: no-cache\n") ) ;
#ifdef	UNICODE
	wcstombs( sendBuf, sendText, sizeof sendBuf ) ;
#else	/* UNICODE */
	strcpy( sendBuf, sendText ) ;
#endif	/* UNICODE */
	len = strlen( sendBuf ) ;

	numSent = send( destSocket, sendBuf, len + 1, 0 ) ;
	if ( numSent != len + 1 ) {
		_tprintf( TEXT("%s: send: %d\n"), g_szProgName, WSAGetLastError() ) ;
		close_sock() ;
		return 96 ;
	}

	_tprintf( TEXT("Storing page to %s\n"), argv[3] ) ;

	hFile = CreateFile( argv[3],
				GENERIC_WRITE,
				FILE_SHARE_READ,
				NULL,
				CREATE_ALWAYS,
				FILE_ATTRIBUTE_NORMAL,
				0 ) ;
	if ( hFile == INVALID_HANDLE_VALUE ) {
		_tprintf( TEXT("%s: fopen: %d\n"), g_szProgName, GetLastError() ) ;
		close_sock() ;
		return 95 ;
	}

	total = 0 ;
	while ( 1 ) {
		numReceived = recv( destSocket, recvText, MAXBUFLEN, 0 ) ;
		if ( ( numReceived == 0 ) || ( numReceived == SOCKET_ERROR ) ) {
			break ;
		}
		WriteFile( hFile, recvText, numReceived, &nWrote, NULL ) ;
		total += numReceived ;
	}

	CloseHandle( hFile ) ;

	if ( numReceived == SOCKET_ERROR ) {
		_tprintf( TEXT("%s: recv: %d\n"), WSAGetLastError() ) ;
	}

	_tprintf( TEXT("Transfered %d byte(s)\n"), total ) ;
	_tprintf( TEXT("Done.\n") ) ;

	close_sock() ;

	return 0 ;
}
